<#--  视图模型处理  -->
    /**
     * 获取模型数据数组
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${view.name}')}
     */
    public getDatas(): any[] {
        return [this.model];
    }

    /**
     * 获取模型数据
     *
     * @returns {*}
     * @memberof ${srfclassname('${view.name}')}
     */
    public getData(): any {
        return this.model;
    }

    /**
     * 加载模型
     *
     * @memberof ${srfclassname('${view.name}')}
     */
    public loadModel(): void {
        const _url: string = '/${app.getPKGCodeName()?lower_case}/${de.getPSSystemModule().codeName?lower_case}/${de.codeName?lower_case}/${view.getPSDEViewCodeName()?lower_case}/getmodel';
        const _data: any = {};
        if (this.engine && this.engine.viewdata && this.engine.viewdata.srfkey) {
            Object.assign(_data, { srfkey: this.engine.viewdata.srfkey });
        }
        const get: Promise<any> = this.$http.get(_url, _data);
        get.then((response: any) => {
            if (!response || response.status !== 200) {
                return;
            }
            const { data: _data } = response;
            if (_data.srfmajortext) {
                Object.assign(this.model, { dataInfo: _data.srfmajortext });
            }
            Object.assign(this.model, _data);
            let viewParam: any = this.$store.getters['viewaction/getAppView'](this.viewtag);
            const routename: any = viewParam.viewmodule.toLocaleLowerCase() + '_' + viewParam.viewname.toLocaleLowerCase();
            this.$tabPageExp.setCurPageCaption(routename, this.model.srfCaption, this.model.dataInfo);
        }).catch((error: any) => {
        });
    }