<#ibizinclude>
../@MACRO/VIEW_HEADER.tsx.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/VIEW_CONTENT.tsx.ftl
</#ibizinclude>

    /**
     * 视图 viewurl
     *
     * @type {string}
     * @memberof ${srfclassname('${view.name}')}
     */
    public viewurl: string = '';

    /**
     * 序列号
     *
     * @private
     * @type {number}
     * @memberof ${srfclassname('${view.name}')}
     */
    private serialNumber: number = this.$util.createSerialNumber();

    /**
     * 请求行为序列号数组
     *
     * @private
     * @type {any[]}
     * @memberof ${srfclassname('${view.name}')}
     */
    private serialsNumber: any[] = [];

    /**
     * 添加序列号
     *
     * @private
     * @param {*} action
     * @param {number} serialnumber
     * @memberof ${srfclassname('${view.name}')}
     */
    private addSerialNumber(action: any, serialnumber: number): void {
        const index = this.serialsNumber.findIndex((serial: any) => Object.is(serial.action, action));
        if (index === -1) {
            this.serialsNumber.push({ action: action, serialnumber: serialnumber })
        } else {
            this.serialsNumber[index].serialnumber = serialnumber;
        }
    }

    /**
     * 删除序列号
     *
     * @private
     * @param {*} action
     * @returns {number}
     * @memberof ${srfclassname('${view.name}')}
     */
    private getSerialNumber(action: any): number {
        const index = this.serialsNumber.findIndex((serial: any) => Object.is(serial.action, action));
        return this.serialsNumber[index].serialnumber;
    }

    /**
     * 加载模型
     *
     * @memberof ${srfclassname('${view.name}')}
     */
    public loadModel(): void {
        const _url: string = '/${app.getPKGCodeName()?lower_case}/${de.getPSSystemModule().codeName?lower_case}/${de.codeName?lower_case}/${view.getPSDEViewCodeName()?lower_case}/getmodel';
        const _data: any = {};
        if (this.engine && this.engine.viewdata) {
            const _viewdata = this.engine.viewdata;
            if (_viewdata.srfkey) {
                Object.assign(_data, { srfkey: _viewdata.srfkey });
            } else if (_viewdata.srfparentdata && _viewdata.srfparentdata.srfparentkey) {
                Object.assign(_data, { srfkey: _viewdata.srfparentdata.srfparentkey });
            }
        }

        this.serialNumber++;
        const serialnumber = this.serialNumber;
        this.addSerialNumber('getmodel', serialnumber);

        const get: Promise<any> = this.$http.get(_url, _data, false, serialnumber);
        get.then((response: any) => {
            const { serialnumber: _serialnumber } = response;
            const lastserialnumber = this.getSerialNumber('getmodel');
            if (_serialnumber && lastserialnumber && _serialnumber < lastserialnumber) {
                return;
            }

            if (!response || response.status !== 200) {
                this.$Notice.error({ title: '加载失败', desc: response.info });
            }
            const { data: _data } = response;
            if (_data.viewurl) {
                this.viewurl = _data.viewurl;
            }
        }).catch((response: any) => {
            const { serialnumber: _serialnumber } = response;
            const lastserialnumber = this.getSerialNumber('getmodel');
            if (_serialnumber && lastserialnumber && _serialnumber < lastserialnumber) {
                return;
            }

            const { data: _data } = response;
            this.$Notice.error({ title: '加载失败', desc: _data.message });
        });
    }

<#ibizinclude>
../@MACRO/LAYOUTPANEL_VIEW.tsx.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/VIEW_BOTTOM.tsx.ftl
</#ibizinclude>