<#assign import_block>
import { Environment } from '@/environments/environment';
</#assign>

<#ibizinclude>
../@MACRO/VIEW_HEADER.tsx.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/VIEW_CONTENT.tsx.ftl
</#ibizinclude>

    /**
     * 上传文件集合
     *
     * @type {any[]}
     * @memberof ImgUploadView
     */
    public files: any[] = [];

    /**
     * 文件的后缀名
     *
     * @type {string[]}
     * @memberof FileUploadView
     */
    public imgExt: string[] = [".png",".jpg",".jpeg",".bmp",".gif"];
    public docExt: string[] = [".doc",".docx"];
    public xlsExt: string[] = [".xls",".xlsx"];
    public pptExt: string[] = [".ppt",".pptx"];
    public pdfExt: string[] = [".pdf"];
    public txtExt: string[] = [".txt"];
    
    /**
     * 上传成功
     *
     * @param {*} response
     * @param {*} file
     * @param {any[]} fileList
     * @returns
     * @memberof FileUploadView
     */
    public onUploadSuccess(response: any, file: any, fileList: any[]) {
        if (!response) {
            return;
        }
        let f: any = { name: response.name, id: response.id }
        if (this.imgExt.indexOf(response.ext) >= 0) {
            f.url = '/assets/img/picture.png';
        } else if (this.txtExt.indexOf(response.ext) >= 0) {
            f.url = '/assets/img/txt.png';
        } else if (this.docExt.indexOf(response.ext) >= 0) {
            f.url = '/assets/img/doc.png';
        } else if (this.pptExt.indexOf(response.ext) >= 0) {
            f.url = '/assets/img/ppt.png';
        } else if (this.xlsExt.indexOf(response.ext) >= 0) {
            f.url = '/assets/img/excel.png';
        } else if (this.pdfExt.indexOf(response.ext) >= 0) {
            f.url = '/assets/img/pdf.png';
        } else {
            f.url = '/assets/img/other.png';
        }
        this.files.push(f);
    }

    public onRemove(file: any) {
        let arr: Array<any> = [];
        this.files.forEach((f: any) => {
            if (f.id != file.id) {
                arr.push({ name: f.name, id: f.id });
            }
        });
        this.files = arr;
    }

    /**
     * 确定
     *
     * @memberof TestEntityPickupView
     */
    public onClickOk(): void {
        this.$emit('viewdataschange', this.files);
        this.$emit('close', null);
    }

    /**
     * 取消
     *
     * @memberof ImgUploadView
     */
    public onClickCancel() {
        this.$emit('close', null);
    }

<#ibizinclude>
../@MACRO/LAYOUTPANEL_VIEW.tsx.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/VIEW_BOTTOM.tsx.ftl
</#ibizinclude>