import Vue from 'vue';
import Router from 'vue-router';
import { Util, AuthGuard } from '@/utils';
import routes from '@/router';
Vue.use(Router);

const router = new Router({
    routes: [
        <#--  路由内容  -->
        {
            path: '/${view.getPSAppModule().getCodeName()?lower_case}_${view.getCodeName()?lower_case}/:${view.getPSAppModule().getCodeName()?lower_case}_${view.getCodeName()?lower_case}?',
            name: '${view.getPSAppModule().getCodeName()?lower_case}_${view.getCodeName()?lower_case}',
            beforeEnter: (to: any, from: any, next: any) => {
                const routerParamsName = '${view.getPSAppModule().getCodeName()?lower_case}_${view.getCodeName()?lower_case}';
                const params: any = {};
                if (to.params && to.params[routerParamsName]) {
                    Object.assign(params, Util.formatMatrixParse(to.params[routerParamsName]));
                }
                const url: string = '${app.getPKGCodeName()?lower_case}/app/${app.getPKGCodeName()?lower_case}/getappdata';
                const auth: Promise<any> = AuthGuard.getInstance().authGuard(url, params, router);
                auth.then(() => {
                    next();
                }).catch(() => {
                    next();
                });
            },
            meta: {  
                caption: '${view.getCaption()}',
                viewType: 'APPINDEX',
                <#if view.getPSSysImage()??>
                imgPath: '${view.getPSSysImage().getImagePath()}',
                iconCls: '${view.getPSSysImage().getCssClass()}',
                </#if>
                requireAuth: <#if view.getAccUserMode?? && view.getAccUserMode()?? && (view.getAccUserMode() == 1 || view.getAccUserMode() == 3)>false<#else>true</#if>,
            },
            component: () => import('@pages/${srffilepath2(view.getPSAppModule().getCodeName())}/${srffilepath2(view.getCodeName())}/${srffilepath2(view.getCodeName())}'),
            children: [
                <#if view.getAllRelatedPSAppViewsEx?? && view.getAllRelatedPSAppViewsEx()??>
                <#list view.getAllRelatedPSAppViewsEx() as funcview>
                <#if !funcview.isPickupView()>
                {
                    path: '${funcview.getPSAppModule().getCodeName()?lower_case}_${funcview.getCodeName()?lower_case}/:${funcview.getPSAppModule().getCodeName()?lower_case}_${funcview.getCodeName()?lower_case}?',
                    name: '${funcview.getPSAppModule().getCodeName()?lower_case}_${funcview.getCodeName()?lower_case}',
                    meta: {  
                        caption: '<#if funcview.isPSDEView()>${funcview.getPSDataEntity().getCodeName()?lower_case}.views.${funcview.getPSDEViewCodeName()?lower_case}.caption<#else>app.views.${funcview.getCodeName()?lower_case}.caption</#if>',
                        <#if funcview.getPSSysImage()??>
                        imgPath: '${funcview.getPSSysImage().getImagePath()}',
                        iconCls: '${funcview.getPSSysImage().getCssClass()}',
                        </#if>
                        requireAuth: <#if funcview.getAccUserMode?? && funcview.getAccUserMode()?? && (funcview.getAccUserMode() == 1 || funcview.getAccUserMode() == 3)>false<#else>true</#if>,
                    },
                    component: () => import('@pages/${srffilepath2(funcview.getPSAppModule().getCodeName())}/${srffilepath2(funcview.getCodeName())}/${srffilepath2(funcview.getCodeName())}'),
                },
                </#if>
                </#list>
                </#if>
            ]
        },
        {
            path: '/login/:login?',
            name: 'login',
            meta: {  
                caption: '登录',
                viewType: 'login',
                requireAuth: false,
                ignoreAddPage: true,
            },
            beforeEnter: (to: any, from: any, next: any) => {
                router.app.$store.commit('resetRootStateData');
                next();
            },
            component: () => import('@components/login/login'),
        },
        {
            path: '/404',
            component: () => import('@components/404/404')
        },
        {
            path: '/500',
            component: () => import('@components/500/500')
        },
        {
            path: '*',
            redirect: '${view.getPSAppModule().getCodeName()?lower_case}_${view.getCodeName()?lower_case}'
        },
        ...routes
    ],
});

export default router;
